// Generated by CoffeeScript 1.3.3
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  module.exports = function(BasePlugin) {
    var HighlightjsPlugin, balUtil, findLanguage, hljs, isPreOrCode, jsdom;
    jsdom = require('jsdom');
    balUtil = require('bal-util');
    hljs = require('highlight.js');
    isPreOrCode = function(element) {
      var _ref;
      if (!element.tagName) {
        return false;
      }
      return (_ref = element.tagName) === 'PRE' || _ref === 'CODE';
    };
    findLanguage = function(element) {
      var classes, matches;
      classes = element.className;
      if (/no[-]?highlight/i.test(classes)) {
        return 'no-highlight';
      }
      matches = classes.match(/lang(?:uage)?-\w+/g);
      if (matches) {
        return matches.pop().match(/lang(?:uage)?-(\w+)/)[1];
      }
      return '';
    };
    return HighlightjsPlugin = (function(_super) {

      __extends(HighlightjsPlugin, _super);

      function HighlightjsPlugin() {
        return HighlightjsPlugin.__super__.constructor.apply(this, arguments);
      }

      HighlightjsPlugin.prototype.name = 'highlightjs';

      HighlightjsPlugin.prototype.config = {
        replaceTab: null,
        sourceFilter: null,
        escape: false,
        removeIndentation: false,
        aliases: {
          coffee: 'coffeescript',
          rb: 'ruby',
          js: 'javascript'
        }
      };

      HighlightjsPlugin.prototype.highlightElement = function(opts) {
        var aliases, childNode, config, element, escape, language, next, parentNode, removeIndentation, replaceTab, result, resultElInner, resultElWrapper, source, sourceFilter, window;
        window = opts.window, element = opts.element, next = opts.next;
        config = balUtil.extend({}, this.config, opts.config);
        escape = config.escape, replaceTab = config.replaceTab, aliases = config.aliases, sourceFilter = config.sourceFilter, removeIndentation = config.removeIndentation;
        childNode = element;
        while (childNode.hasChildNodes() && isPreOrCode(childNode.childNodes[0])) {
          childNode = childNode.childNodes[0];
        }
        parentNode = element;
        while (isPreOrCode(parentNode.parentNode)) {
          parentNode = parentNode.parentNode;
        }
        if (parentNode.className.indexOf('highlighted') !== -1) {
          return next();
        }
        source = childNode.innerHTML;
        if (removeIndentation !== false) {
          source = balUtil.removeIndentation(source);
        }
        language = childNode.getAttribute('lang') || parentNode.getAttribute('lang');
        language = language.trim() || findLanguage(childNode) || findLanguage(parentNode);
        if (language !== 'no-highlight') {
          if (escape !== true) {
            source = source.replace(/&amp;/gm, '&').replace(/&lt;/gm, '<').replace(/&gt;/gm, '>');
          }
          if (sourceFilter != null) {
            if (sourceFilter instanceof Function) {
              source = sourceFilter(source, language);
            } else if (sourceFilter instanceof Array && sourceFilter.length === 2) {
              source = source.replace(sourceFilter[0], sourceFilter[1]);
            }
          }
          if (replaceTab) {
            hljs.fixMarkup(source, replaceTab);
          }
          language = language.toLowerCase();
          try {
            if (language && aliases[language]) {
              language = aliases[language];
            }
            if (language && (hljs.LANGUAGES[language] != null)) {
              result = hljs.highlight(language, source);
            } else {
              result = hljs.highlightAuto(source);
            }
            language = result.language;
            result = result.value;
          } catch (err) {
            if (err) {
              return next(err);
            }
          }
        } else {
          result = source;
        }
        resultElWrapper = window.document.createElement('div');
        resultElWrapper.innerHTML = "<pre class=\"highlighted\"><code class=\"" + language + "\">" + result + "</code></pre>";
        resultElInner = resultElWrapper.childNodes[0];
        parentNode.parentNode.replaceChild(resultElInner, parentNode);
        next();
        return this;
      };

      HighlightjsPlugin.prototype.renderDocument = function(opts, next) {
        var extension, file, plugin;
        extension = opts.extension, file = opts.file;
        plugin = this;
        if (file.type === 'document' && extension === 'html') {
          return jsdom.env({
            html: "<html><body>" + opts.content + "</body></html>",
            features: {
              QuerySelector: true,
              MutationEvents: false
            },
            done: function(err, window) {
              var element, elements, tasks, _i, _len, _ref;
              if (err) {
                return next(err);
              }
              elements = window.document.querySelectorAll('code pre, pre code, .highlight');
              if (elements.length === 0) {
                return next();
              }
              tasks = new balUtil.Group(function(err) {
                if (err) {
                  return next(err);
                }
                opts.content = window.document.body.innerHTML;
                return next();
              });
              tasks.total = elements.length;
              for (_i = 0, _len = elements.length; _i < _len; _i++) {
                element = elements[_i];
                plugin.highlightElement({
                  window: window,
                  element: element,
                  next: tasks.completer(),
                  config: (_ref = file.attributes.plugins) != null ? _ref.highlightjs : void 0
                });
              }
              return true;
            }
          });
        } else {
          return next();
        }
      };

      return HighlightjsPlugin;

    })(BasePlugin);
  };

}).call(this);
